/*  GP2Xengine WAV support
    Copyright (C) 2006  Hermes/PS2Reality 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



#include "wav.h"
#include "pce.h"


int wave_is_reading=0;
extern unsigned actual_track;

_waveinfo waveinfo;

int PCE_time=0;
int WAV_time=0;
extern int skip_wave_sound;
static int WAV_LENBUF=44100;
static FILE *FWAV=0;
static int WAV_START=0; 
static int WAV_POSITION=0;
static int WAV_NSAMPLES=0;
static int WAV_SECT=0; // se usa para simular la lectura por sectores

static short *wave_ring[WAV_NUMBUF];
static short wave_buf[WAV_LENBUF_MAX*WAV_NUMBUF];
static int wave_counter=-1;
static int wave_readed=0;
static int wave_loop=0;
static int wave_end=0;




static short tabpcm8[256];
static creattabpcm() // genera la tabla PCM 8 bits
{
int n,m;
int AMP=10; // factor de amplificacion
for(n=0;n<256;n++)
{
m=((65535*n)/255);
m-=32768;
m=(m*AMP)/8;
if(m<-32768) m=-32768;
if(m>32767) m=32767;

tabpcm8[n]=m;
}

}


int close_wav()
{
int n;
FILE *FWAV2=FWAV;
if(!FWAV) return 0;
while(wave_is_reading) usleep(50);
FWAV=0;
wave_counter=-1;
for(n=0;n<WAV_NUMBUF;n++)
	{
	wave_ring[n]=&wave_buf[WAV_LENBUF_MAX*n];
	wave_buf[WAV_LENBUF_MAX*n]=0;
	}
skip_wave_sound=1;
fclose(FWAV2);
skip_wave_sound=0;

return 0;
}


int open_wav(char *name)
{

unsigned IDriff,ID1wave,ID2wave,IDdata;
unsigned lriff,lwavef,lwave;
int n;
static int one=1;
if(one) {one=0;creattabpcm();}
PCE_time=0;
WAV_time=0;

for(n=0;n<WAV_NUMBUF;n++)
	{
	wave_ring[n]=&wave_buf[WAV_LENBUF_MAX*n];
	wave_buf[WAV_LENBUF_MAX*n]=0;
	}
wave_readed=0;
wave_end=0x7fffffff; // longitud 'infinita'
wave_loop=1;
wave_counter=1;
WAV_POSITION=0;
WAV_START=0; 
WAV_NSAMPLES=0;
WAV_SECT=0;

skip_wave_sound=1;
FWAV = fopen(name, "rb");
if(FWAV==NULL) {skip_wave_sound=0;return -1;}
/* lee cabecera */

fread(&IDriff,1,4,FWAV);

if(IDriff!=0x46464952)
  {
//  printf("No encontrado formato RIFF\n");
  fclose(FWAV);FWAV=0;{skip_wave_sound=0;return -2;}
  }
fread(&lriff,1,4,FWAV);


fread(&ID1wave,1,4,FWAV);
fread(&ID2wave,1,4,FWAV);
if(ID1wave!=0x45564157 || ID2wave!=0x20746D66)
  {
  //printf("No encontrado formato WAVE\n");
  fclose(FWAV);FWAV=0;{skip_wave_sound=0;return -2;}
  }
fread(&lwavef,1,4,FWAV);
if(lwavef!=16) 
 {
 // printf("Formato WAVE Extendido, no soportado\n");
 fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
 }
fread(&waveinfo,1,lwavef,FWAV);
if(waveinfo.wFormatTag!=1)
  {
  //printf("No es formato PCM! \n"); 
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }

fread(&IDdata,1,4,FWAV);
if(IDdata!=0x61746164)
  {
  //printf("No encontrada seccion DATA \n");
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }
fread(&lwave,1,4,FWAV);

 if(waveinfo.nBitsPerSample!=8 && waveinfo.nBitsPerSample!=16)
  {
  //printf("Numero de BITS por Sample no es 8 o 16 \n");
  fclose(FWAV);FWAV=0;skip_wave_sound=0;return -2;
  }


WAV_NSAMPLES=lwave/waveinfo.nBlockAlign;// numero de samples totales
//fseek(FWAV,0,SEEK_CUR);
WAV_START=ftell(FWAV);
WAV_SECT=(waveinfo.nSamplesPerSecond*waveinfo.nChannels*(waveinfo.nBitsPerSample>>3))/75;
/*skip_wave_sound=2;
wav_loop();
skip_wave_sound=0;*/

WAV_LENBUF=waveinfo.nSamplesPerSecond*waveinfo.nChannels;	
	
skip_wave_sound=0;
return 0;
}



void wav_loop()
{
int n,m;
short *buf;
if(!FWAV) return;

for(n=0;n<WAV_NUMBUF;n++)
	{//0
	buf=wave_ring[n];
	if(buf[0]==0)
		{//1
		if(waveinfo.nBitsPerSample==8)
		{//2
		skip_wave_sound=1;
		wave_is_reading=1;
		 m=fread(&buf[1],1,WAV_LENBUF,FWAV);
		 wave_is_reading=0;
		 skip_wave_sound=0;
		 if(m<WAV_LENBUF || (wave_readed+m)>=wave_end)
			{//3
			if(m<0) return;
			if(wave_loop)
			{//4
			wave_is_reading=1;
			fseek(FWAV,WAV_START,SEEK_SET); // loop
			wave_is_reading=0;
			wave_readed=0;
			}//4
            memset(((char *)&buf[1])+m,0,WAV_LENBUF-m); // rellena con 0 hasta el final
	
			
			}//3
			else wave_readed+=m;
		 buf[0]=1;return;
		 
  

		}//2
		else
		{//2
		skip_wave_sound=1;
		wave_is_reading=1;
		m=fread(&buf[1],1,WAV_LENBUF*2,FWAV);
		skip_wave_sound=0;
		wave_is_reading=0;
		if(m<WAV_LENBUF*2 || (wave_readed+m)>=wave_end)
			{
			if(m<0) return;
			if(wave_loop)
			{
			wave_is_reading=1;
			fseek(FWAV,WAV_START,SEEK_SET); // loop
			wave_is_reading=0;
			wave_readed=0;
			}
            memset(((char *)&buf[1])+m,0,WAV_LENBUF*2-m); // rellena con 0 hasta el final
			}
			else wave_readed+=m;
		}
		buf[0]=1;return;
		}
	
	}

}



void wav_mix_samples(short *s,int samples)
{
int v,v2;
//samples>>=1;
short *buf;
unsigned char *buf8;
int n,m;
if(!FWAV) return;
if(wave_counter<=0) return;
/*if((PCE_time+1000)<WAV_time) // mete un silencio
	{
	return;
	}
PCE_time-=WAV_time;

WAV_time=(samples*1000)/22050;
*/
for(n=0;n<WAV_NUMBUF;n++)
	{
	buf=wave_ring[0];
	if(buf[0]==0)
		{
		for(m=1;m<WAV_NUMBUF;m++)
			{
			wave_ring[m-1]=wave_ring[m];
			}
		wave_ring[m-1]=buf;
		continue;
		}
if(waveinfo.nBitsPerSample==8)
	{//0
	buf8=(unsigned char *) buf;
	if(waveinfo.nSamplesPerSecond==44100) // 8 bits 44100hz
	 {//1
	 if(waveinfo.nChannels==2) //stereo
	 {//2
		
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	   
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		}//3
	 }//2
	 else // mono
	 {//2
	 samples=(samples>>1)<<1;
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	 v2=tabpcm8[buf8[wave_counter+1]];
	 v=*s + v2;
   	if(v<-32768) v=-32768; if(v>32767) v=32767;
	 *s++=v;samples--;
	 v=*s + v2;
   	 if(v<-32768) v=-32768; if(v>32767) v=32767;
	 *s++=v;samples--;
		wave_counter++;
	  }//3

	 }//2
	 }//1
	 if(waveinfo.nSamplesPerSecond==22050) // 8 bits 22050hz
	 {//1
	 samples=(samples>>2)<<2;
     if(waveinfo.nChannels==2) //stereo
	 {//2s
	 while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	   
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + tabpcm8[buf8[wave_counter+2]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		
		v=*s + tabpcm8[buf8[wave_counter+1]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + tabpcm8[buf8[wave_counter+2]];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		//samples-=2;
		//s+=2;


		wave_counter+=2;
		}//3
	 }//2
	 else //mono
	 {//2
	 
	while(wave_counter<WAV_LENBUF && samples>0)
		{//3
	    v2=tabpcm8[buf8[wave_counter+1]];
		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		
		
		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		v=*s + v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;

		wave_counter++;
		}//2
	 
	 }//2
	}//1
	}//0
	#if 1
	else //
	{
	if(waveinfo.nBitsPerSample==16)
	 {//1
	 if(waveinfo.nSamplesPerSecond==44100) // 16 bits 44100hz
	  {//2
	  if(waveinfo.nChannels==2) //stereo
	   {//3
	    while(wave_counter<WAV_LENBUF && samples>0)
		{//4
	   
		v=*s + buf[wave_counter];
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		} //4
	   } //3
	   else //mono
	   { //3
	   samples=(samples>>1)<<1;
	   while(wave_counter<WAV_LENBUF && samples>0)
		{ //4
	    v2= buf[wave_counter];
		v=*s +v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		v=*s +v2;
		
		if(v<-32768) v=-32768; if(v>32767) v=32767;
		*s++=v;samples--;
		wave_counter++;
		}//4
	   }//3

	  }//2
	  else //16 bits 22050
	  {//2
	  if(waveinfo.nSamplesPerSecond==22050) // 16 bits 22050hz
	   {//3
	   samples=(samples>>2)<<2;
	    if(waveinfo.nChannels==2) //stereo
	     {//4
	     while(wave_counter<WAV_LENBUF && samples>0)
		  {//5
	   
		  v=*s + buf[wave_counter];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;

		  v=*s + buf[wave_counter+1];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;
		
		
	      v=*s + buf[wave_counter];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;

		  v=*s + buf[wave_counter+1];
		
		  if(v<-32768) v=-32768; if(v>32767) v=32767;
		  *s++=v;samples--;
		
		//samples-=2;
		//s+=2;
          wave_counter+=2;
		 }//5
	    }//4
	   else //mono
	   {//4
	   
	   while(wave_counter<WAV_LENBUF && samples>0)
		 {//5
	     v2=buf[wave_counter];
		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;
		
		
		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 v=*s + v2;
		
		 if(v<-32768) v=-32768; if(v>32767) v=32767;
		 *s++=v;samples--;

		 wave_counter++;
		 }//5
	    }//4
	   }//3
	  }//2

	  }//1
	}//0
	#endif
     



	 if(wave_counter>=WAV_LENBUF)
		{
		for(m=n+1;m<WAV_NUMBUF;m++)
			{
			wave_ring[m-1]=wave_ring[m];
			}
		 wave_ring[m-1]=buf;
		buf[0]=0;wave_counter=1;
		}
	else break;
	}

}

int CD_track_cmd[8]={0,0,0,0,0,0,0,0};

void h_play_track (int track)
{
if(track>nb_max_track) return;
CD_track_cmd[0]=1;CD_track_cmd[1]=track;
close_wav();
if(CD_emulation!=3) return;
if(track>0  && CD_track[track].type != 4)
	{
	if(CD_track[track].filename[0]!=0) open_wav(CD_track[track].filename);
	}
return;


}
void h_play_sectors (int begin_sect, int sect_len, char repeat)
{
  int result;
CD_track_cmd[0]=2;CD_track_cmd[1]=begin_sect;CD_track_cmd[2]=sect_len;CD_track_cmd[3]=repeat;
close_wav();
if(CD_emulation!=3) return;
  for (result = nb_max_track; result>1;result--)
    {
      if (((unsigned)begin_sect >= CD_track[result].beg_lsn) &&
	  		((unsigned)begin_sect < CD_track[result].beg_lsn + CD_track[result].length) &&   CD_track[result].type !=4)
			break;
    }
if(result==0) return;
if(CD_track[result].filename[0]==0) return; 
  if (CD_track[result].type !=4)
    {
	  open_wav(CD_track[result].filename);
	  if(FWAV) {begin_sect-=CD_track[result].beg_lsn;
		        WAV_START+=(begin_sect)*WAV_SECT;
		        wave_end=sect_len*WAV_SECT;
				wave_loop=(int) repeat;
				fseek(FWAV,WAV_START,SEEK_SET);
				wave_readed=0;
				}
	}
}

void h_stop_track ()
{
if(CD_emulation!=3) return;
close_wav();
}



int ReadTocList(char *name)
{
unsigned mm=0,ss=0,ff=0;
int pos=0;
unsigned lba;
int ret,track,n;
int leadin=0;
FILE *fd,*fd2;

byte Min, Sec, Fra;
unsigned char str_buf[256];
unsigned char str_buf2[256];
actual_track=0;
skip_wave_sound=1;

fd=fopen(name,"r");
skip_wave_sound=0;
if(fd==NULL) {return -1;}

pos=0;while(name[pos]!=0) pos++;
while(name[pos]!='/' && pos>0) pos--;
pos++;

track=1;
lba=150;
skip_wave_sound=1;

while(1)
	{
	if(fgets(str_buf,255,fd)==0) break;

	if(leadin==0)  // esto se usa para ignorar todos los comentarios hasta que aparezca la palabra Leadin
		{
		ret=sscanf(str_buf,"syscard: %s",str_buf2); //system cdrom
		if(ret==1)
			{
			if(str_buf2[0]=='#')
				{
				sprintf(CD_track[0].filename,"/mnt/sd/roms/pcengine/%s",&str_buf2[1]);
				}
			else 
				{memcpy(CD_track[0].filename,name,pos);CD_track[0].filename[pos]=0;strcat(CD_track[0].filename,str_buf2);}
			continue;
			}
		if (strcasestr (str_buf, "Leadin")) leadin=1;
		continue;
		}

		
    ret=sscanf(str_buf,"%s %u:%2u:%2u",str_buf2,&mm,&ss,&ff);
	if(ret>0)
		{
		
	

			mm&=255;ss&=255;ff&=255;
			
		 
		  CD_track[track].length =  msf2nb_sect (mm ,ss,ff);
		  if (strcasestr (str_buf2, "Position:")) {lba=CD_track[track].length;continue;}
		  if (strcasestr (str_buf2, "Pregap:")) {lba+=CD_track[track].length;continue;}
		  if (strcasestr (str_buf2, ".iso") || strcasestr (str_buf2, ".ISO")) {/*lba+=75;*/CD_track[track].type = 4;}
          else CD_track[track].type = 0;
		  


		  nb_sect2msf (lba, &Min, &Sec, &Fra);
		  CD_track[track].beg_min = binbcd[Min];
		  CD_track[track].beg_sec = binbcd[Sec];
		  CD_track[track].beg_fra = binbcd[Fra];
		  CD_track[track].beg_lsn =lba-150;
		
          CD_track[track].filename[0]=0;
		  
		if (strcasestr (str_buf2, "Leadout")) break;
		 memcpy(CD_track[track].filename,name,pos);
		 CD_track[track].filename[pos]=0;
		 strcat(CD_track[track].filename,str_buf2);
		 
         if(CD_track[track].type ==0 && ret<4)
			  {
			  if(!open_wav(CD_track[track].filename))
				  {
					skip_wave_sound=1;fseek(FWAV,0,SEEK_END);
		
				  CD_track[track].length=((ftell(FWAV)-WAV_START)*(44100/waveinfo.nSamplesPerSecond)*(16/waveinfo.nBitsPerSample)*(2/waveinfo.nChannels))/2352;
				  if(track==1) if( CD_track[track].length<(47*75+65)) CD_track[track].length=(47*75+65);
				  
				  close_wav();skip_wave_sound=1;
                  
				  }
			  else {skip_wave_sound=1;}
			  }

		 if(CD_track[track].type == 4)
			{
			 fd2=fopen(CD_track[track].filename,"rb");
			 if(fd2)
			{
			CD_track[track].length = filesize (fd2) / 2048;
		
			fclose(fd2);
			}
			}
			

        lba+=CD_track[track].length;
        track++;
		
		}
	

	}

	
nb_max_track=track-1;


fclose(fd);
skip_wave_sound=0;
return 0;
}